/**
 * Baobab-React Decorators
 * ========================
 *
 * ES7 decorators sugar for higher order components.
 */
'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});
exports.root = root;
exports.branch = branch;

var _higherOrderJs = require('./higher-order.js');

function root(tree) {
  return function (Component) {
    return (0, _higherOrderJs.root)(Component, tree);
  };
}

function branch(specs) {
  return function (Component) {
    return (0, _higherOrderJs.branch)(Component, specs);
  };
}