/**
 * Baobab-React Wrapper Component
 * ===============================
 *
 * ES6 wrapper component.
 */
'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; desc = parent = getter = undefined; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) subClass.__proto__ = superClass; }

var _reactAddons = require('react/addons');

var _reactAddons2 = _interopRequireDefault(_reactAddons);

var _utilsPropTypesJs = require('./utils/prop-types.js');

var _utilsPropTypesJs2 = _interopRequireDefault(_utilsPropTypesJs);

var _utilsHelpersJs = require('./utils/helpers.js');

var _utilsHelpersJs2 = _interopRequireDefault(_utilsHelpersJs);

var _utilsTypeJs = require('./utils/type.js');

var _utilsTypeJs2 = _interopRequireDefault(_utilsTypeJs);

/**
 * Helpers
 */
function rootPass(props) {
  var children = props.children;
  var tree = props.tree;

  var otherProps = _objectWithoutProperties(props, ['children', 'tree']);

  return _extends({}, otherProps);
}

function branchPass(props, state) {
  var children = props.children;
  var cursors = props.cursors;
  var facets = props.facets;

  var otherProps = _objectWithoutProperties(props, ['children', 'cursors', 'facets']);

  return _extends({}, otherProps, state);
}

function renderChildren(children, props) {
  if (!children) return null;

  if (!Array.isArray(children)) {
    return _reactAddons2['default'].addons.cloneWithProps(children, props);
  } else {
    var group = _reactAddons2['default'].Children.map(children, function (child) {
      return _reactAddons2['default'].addons.cloneWithProps(child, props);
    });

    return _reactAddons2['default'].createElement(
      'span',
      null,
      group
    );
  }
}

/**
 * Root wrapper
 */

var Root = (function (_React$Component) {
  _inherits(Root, _React$Component);

  function Root() {
    _classCallCheck(this, Root);

    _get(Object.getPrototypeOf(Root.prototype), 'constructor', this).apply(this, arguments);
  }

  _createClass(Root, [{
    key: 'getChildContext',

    // Handling child context
    value: function getChildContext() {
      return {
        tree: this.props.tree
      };
    }
  }, {
    key: 'render',

    // Rendering children
    value: function render() {
      return renderChildren(this.props.children, rootPass(this.props));
    }
  }], [{
    key: 'propTypes',
    value: {
      tree: _utilsPropTypesJs2['default'].baobab
    },
    enumerable: true
  }, {
    key: 'childContextTypes',
    value: {
      tree: _utilsPropTypesJs2['default'].baobab
    },
    enumerable: true
  }]);

  return Root;
})(_reactAddons2['default'].Component);

exports.Root = Root;

/**
 * Branch wrapper
 */

var Branch = (function (_React$Component2) {
  _inherits(Branch, _React$Component2);

  _createClass(Branch, [{
    key: 'getChildContext',

    // Child context
    value: function getChildContext() {
      return {
        cursors: this.cursors
      };
    }
  }], [{
    key: 'contextTypes',
    value: {
      tree: _utilsPropTypesJs2['default'].baobab
    },
    enumerable: true
  }, {
    key: 'childContextTypes',
    value: {
      cursors: _utilsPropTypesJs2['default'].cursors
    },
    enumerable: true
  }]);

  // Building initial state

  function Branch(props, context) {
    _classCallCheck(this, Branch);

    _get(Object.getPrototypeOf(Branch.prototype), 'constructor', this).call(this, props, context);

    if (props.cursors) {
      var solvedMapping = _utilsHelpersJs2['default'].solveMapping(props.cursors, props, context);

      if (!solvedMapping) throw _utilsHelpersJs2['default'].makeError('baobab-react:higher-order.branch: given mapping is invalid.', { mapping: solvedMapping });

      // Creating the watcher
      this.watcher = this.context.tree.watch(solvedMapping);

      // Instantiating cursors
      this.cursors = {};

      var k = undefined;
      for (k in solvedMapping) if (_utilsTypeJs2['default'].cursor(solvedMapping[k])) this.cursors[k] = solvedMapping[k];else this.cursors[k] = this.context.tree.select(solvedMapping[k]);

      this.state = this.watcher.get();
    }
  }

  _createClass(Branch, [{
    key: 'componentWillMount',

    // On component mount
    value: function componentWillMount() {
      if (!this.watcher) return;

      var handler = (function () {
        this.setState(this.watcher.get());
      }).bind(this);

      this.watcher.on('update', handler);
    }
  }, {
    key: 'render',

    // Render shim
    value: function render() {
      return renderChildren(this.props.children, branchPass(this.props, this.state));
    }
  }, {
    key: 'componentWillUnmount',

    // On component unmount
    value: function componentWillUnmount() {
      if (!this.watcher) return;

      // Releasing watcher
      this.watcher.release();
      this.watcher = null;
    }
  }, {
    key: 'componentWillReceiveProps',

    // On new props
    value: function componentWillReceiveProps(props) {
      if (!this.watcher) return;

      var solvedMapping = _utilsHelpersJs2['default'].solveMapping(props.cursors, props, this.context);

      if (!solvedMapping) throw _utilsHelpersJs2['default'].makeError('baobab-react:higher-order.branch: given mapping is invalid.', { mapping: solvedMapping });

      // Creating the watcher
      this.watcher = this.context.tree.watch(solvedMapping);

      // Instantiating cursors
      this.cursors = {};

      var k = undefined;
      for (k in solvedMapping) if (_utilsTypeJs2['default'].cursor(solvedMapping[k])) this.cursors[k] = solvedMapping[k];else this.cursors[k] = this.context.tree.select(solvedMapping[k]);

      this.setState(this.watcher.get());
    }
  }]);

  return Branch;
})(_reactAddons2['default'].Component);

exports.Branch = Branch;